(* Title:  Knowledge/biegelinie-3.sml
   Author: Walther Neuper 050826
   (c) due to copyright terms
*)
"-----------------------------------------------------------------";
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"----------- SubProblem: auto method [Biegelinien,setzeRandbedingungenEin]--------------------";
"----------- SubProblem: me method [Biegelinien,setzeRandbedingungenEin]----------------------";
"---------------------------------------------------------------------------------------------";
"---------------------------------------------------------------------------------------------";
"---------------------------------------------------------------------------------------------";

open Tactic;
open Pos;
open Solve;
open Ctree;
open Kernel;
open Test_Code;

"----------- SubProblem: auto method [Biegelinien,setzeRandbedingungenEin]--------------------";
"----------- SubProblem: auto method [Biegelinien,setzeRandbedingungenEin]--------------------";
"----------- SubProblem: auto method [Biegelinien,setzeRandbedingungenEin]--------------------";
val fmz = ["Funktionen [Q x = c + - 1 * q_0 * x," ^
    "M_b x = c_2 + c * x + - 1 * q_0 / 2 * x \<up> 2," ^
    "y' x = c_3 + 1 / (- 1 * EI) * (c_2 * x + c / 2 * x \<up> 2 + - 1 * q_0 / 6 * x \<up> 3)," ^
    "y x = c_4 + c_3 * x + 1 / (- 1 * EI) * (c_2 / 2 * x \<up> 2 + c / 6 * x \<up> 3 + - 1 * q_0 / 24 * x \<up> 4)]",
	   "Randbedingungen [y 0 = (0::real), y L = 0, M_b 0 = 0, M_b L = 0]",
	   "Gleichungen equ_s"];
val (dI',pI',mI') = ("Biegelinie", ["setzeRandbedingungen", "Biegelinien"],
		     ["Biegelinien", "setzeRandbedingungenEin"]);

States.reset ();  
CalcTree @{context} [(fmz, (dI',pI',mI'))];
Iterator 1;
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;

val ((pt, p),_) = States.get_calc 1;
if p = ([], Res) andalso (get_obj g_res pt (fst p) |> UnparseC.term @{context}) =
  "[0 = - 1 * c_4 / - 1,\n 0 =\n (- 24 * c_4 + - 24 * L * c_3 + 12 * L \<up> 2 * c_2 + 4 * L \<up> 3 * c +\n  - 1 * L \<up> 4 * q_0) /\n - 24,\n 0 = c_2, 0 = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2]"
(*"[0 = - 1 * c_4 / - 1,\n 0 =\n (- 24 * c_4 * EI + - 24 * L * c_3 * EI + 12 * L \<up> 2 * c_2 +\n  4 * L \<up> 3 * c +\n  - 1 * L \<up> 4 * q_0) /\n (- 24 * EI),\n 0 = c_2, 0 = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2]"
  ^^^ BEFORE fun Calc_Binop.simplify IS EVALUATEDO BY Simplifier.rewrite  *)
then () else error "auto method [Biegelinien,setzeRandbedingungenEin] changed";


"----------- SubProblem: me method [Biegelinien,setzeRandbedingungenEin]----------------------";
"----------- SubProblem: me method [Biegelinien,setzeRandbedingungenEin]----------------------";
"----------- SubProblem: me method [Biegelinien,setzeRandbedingungenEin]----------------------";
val fmz = ["Funktionen [Q x = c + - 1 * q_0 * x," ^
    "M_b x = c_2 + c * x + - 1 * q_0 / 2 * x \<up> 2," ^
    "y' x = c_3 + 1 / (- 1 * EI) * (c_2 * x + c / 2 * x \<up> 2 + - 1 * q_0 / 6 * x \<up> 3)," ^
    "y x = c_4 + c_3 * x + 1 / (- 1 * EI) * (c_2 / 2 * x \<up> 2 + c / 6 * x \<up> 3 + - 1 * q_0 / 24 * x \<up> 4)]",
	   "Randbedingungen [y 0 = (0::real), y L = 0, M_b 0 = 0, M_b L = 0]",
	   "Gleichungen equ_s"];
val (dI',pI',mI') = ("Biegelinie", ["setzeRandbedingungen", "Biegelinien"],
		     ["Biegelinien", "setzeRandbedingungenEin"]);
val p = e_pos'; val c = [];
val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "Funktionen\n [Q x = c + - 1 * q_0 * x, M_b x = c_2 + c * x + - 1 * q_0 / 2 * x \<up> 2,\n  y' x =\n  c_3 +\n  1 / (- 1 * EI) *\n  (c_2 * x + c / 2 * x \<up> 2 + - 1 * q_0 / 6 * x \<up> 3)]" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "Funktionen\n [M_b x = c_2 + c * x + - 1 * q_0 / 2 * x \<up> 2, Q x = c + - 1 * q_0 * x,\n  y' x =\n  c_3 +\n  1 / (- 1 * EI) *\n  (c_2 * x + c / 2 * x \<up> 2 + - 1 * q_0 / 6 * x \<up> 3),\n  y x =\n  c_4 + c_3 * x +\n  1 / (- 1 * EI) *\n  (c_2 / 2 * x \<up> 2 + c / 6 * x \<up> 3 + - 1 * q_0 / 24 * x \<up> 4)]" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val  Add_Given "Randbedingungen [y 0 = 0]" = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "Randbedingungen [y 0 = 0, y L = 0]" = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; (*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; 
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "Gleichungen equ_s" = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Theory "Biegelinie" = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Problem ["setzeRandbedingungen", "Biegelinien"] = nxt
(*[], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Method ["Biegelinien", "setzeRandbedingungenEin"] = nxt
(*[], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Apply_Method ["Biegelinien", "setzeRandbedingungenEin"] = nxt;

"----- Randbedingung y 0 = 0 in SUBpbl with met [Equation, fromFunction]";
(*[1], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Model_Problem = nxt;
(*+*)if (#1 o (get_obj g_fmz pt)) (fst p) = 
(*+*)  ["functionEq (M_b x = c_2 + c * x + - 1 * q_0 / 2 * x \<up> 2)",
(*+*)   "substitution (M_b 0 = 0)", "equality equ'''"]then ()
(*+*)else error "Met setzeRandbedingungenEin CHANGED";
(*+*)(writeln o Istate.string_of @{context}) (get_istate_LI pt p);

(*[1], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "functionEq (M_b x = c_2 + c * x + - 1 * q_0 / 2 * x \<up> 2)" = nxt
(*[1], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*[1], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*[1], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*[1], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Apply_Method ["Equation", "fromFunction"] = nxt

(*[1, 1], Frm*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Substitute ["x = 0"] = nxt
                                                     val "M_b x = c_2 + c * x + - 1 * q_0 / 2 * x \<up> 2" = f2str f
(*[1, 1], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Substitute ["M_b 0 = 0"] = nxt
(*[1, 2], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Rewrite_Set "norm_Rational" = nxt
(*[1, 3], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val "0 = c_2" = f2str f
                                                     val Check_Postcond ["makeFunctionTo", "equation"] = nxt;

(*[1], Res*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val "0 = c_2" = f2str f
                                                  val Subproblem ("Biegelinie", ["makeFunctionTo", "equation"]) = nxt
(*[2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Model_Problem = nxt;
(*+*)if (#1 o (get_obj g_fmz pt)) (fst p) = [
(*+*)  "functionEq\n (y x =\n  c_4 + c_3 * x +\n  1 / (- 1 * EI) *\n  (c_2 / 2 * x \<up> 2 + c / 6 * x \<up> 3 + - 1 * q_0 / 24 * x \<up> 4))",
(*+*)  "substitution (y 0 = 0)", "equality equ'''"] then ()
(*+*)else error "biegelinie.sml metsetzeRandbed*Ein bb ";

(*[2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "functionEq\n (y x =\n  c_4 + c_3 * x +\n  1 / (- 1 * EI) *\n  (c_2 / 2 * x \<up> 2 + c / 6 * x \<up> 3 + - 1 * q_0 / 24 * x \<up> 4))" =nxt
(*[2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*[2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*[2], Pbl*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Method ["Equation", "fromFunction"] = nxt
(*[2], Met*)val (p,_,f,nxt,_,pt) = me nxt p c pt; val Apply_Method ["Equation", "fromFunction"] = nxt

val (p,_,f,nxt,_,pt) = me nxt p c pt; val Substitute ["x = 0"] = nxt
                                      val "y x =\nc_4 + c_3 * x +\n1 / (- 1 * EI) *\n(c_2 / 2 * x \<up> 2 + c / 6 * x \<up> 3 + - 1 * q_0 / 24 * x \<up> 4)" = f2str f
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Substitute ["y 0 = 0"] = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Rewrite_Set "norm_Rational" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Check_Postcond ["makeFunctionTo", "equation"] = nxt
                                      val "0 = - 1 * c_4 / - 1" = f2str f

val (p,_,f,nxt,_,pt) = me nxt p c pt; val Subproblem ("Biegelinie", ["makeFunctionTo", "equation"]) = nxt
                                      val "0 = - 1 * c_4 / - 1" = f2str f
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Model_Problem = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "functionEq\n (y x =\n  c_4 + c_3 * x +\n  1 / (- 1 * EI) *\n  (c_2 / 2 * x \<up> 2 + c / 6 * x \<up> 3 + - 1 * q_0 / 24 * x \<up> 4))" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "substitution (y L = 0)" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "equality equ'''" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Theory "Biegelinie" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Problem ["makeFunctionTo", "equation"] = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Method ["Equation", "fromFunction"] = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Apply_Method ["Equation", "fromFunction"] = nxt

val (p,_,f,nxt,_,pt) = me nxt p c pt; val Substitute ["x = L"] = nxt
                                      val "y x =\nc_4 + c_3 * x +\n1 / (- 1 * EI) *\n(c_2 / 2 * x \<up> 2 + c / 6 * x \<up> 3 + - 1 * q_0 / 24 * x \<up> 4)" = f2str f
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Substitute ["y L = 0"] = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Rewrite_Set "norm_Rational" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Check_Postcond ["makeFunctionTo", "equation"] = nxt
                                      val "0 =\n(- 24 * c_4 + - 24 * L * c_3 + 12 * L \<up> 2 * c_2 + 4 * L \<up> 3 * c +\n - 1 * L \<up> 4 * q_0) /\n- 24" = f2str f

val (p,_,f,nxt,_,pt) = me nxt p c pt; val Subproblem ("Biegelinie", ["makeFunctionTo", "equation"]) = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Model_Problem = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "functionEq (M_b x = c_2 + c * x + - 1 * q_0 / 2 * x \<up> 2)" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "substitution (M_b L = 0)" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "equality equ'''" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Theory "Biegelinie" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Problem ["makeFunctionTo", "equation"] = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Method ["Equation", "fromFunction"] = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Apply_Method ["Equation", "fromFunction"] = nxt

val (p,_,f,nxt,_,pt) = me nxt p c pt; val Substitute ["x = L"] = nxt
                                      val "M_b x = c_2 + c * x + - 1 * q_0 / 2 * x \<up> 2" = f2str f
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Substitute ["M_b L = 0"] = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Rewrite_Set "norm_Rational" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Check_Postcond ["makeFunctionTo", "equation"] = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Check_Postcond ["setzeRandbedingungen", "Biegelinien"] = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val End_Proof' = nxt
(*WN230825 outcommented version           "[0 = c_4,\n             0 =\n c_4 + L * c_3 +\n (12 * L \<up> 2 * c_2 + 4 * L \<up> 3 * c + - 1 * L \<up> 4 * q_0) / (- 24 * EI),\n           0 = c_2, 0 = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2]" *)
(*WN230825 (outcommented since ???        "[0 = c_4,\n             0 =\n c_4 + L * c_3 +\n (12 * L \<up> 2 * c_2 + 4 * L \<up> 3 * c + - 1 * L \<up> 4 * q_0) /\n (- 1 * EI * 24),\n     0 = c_2, 0 = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2]"*)
                                      val "[0 = c_2, 0 = - 1 * c_4 / - 1,\n 0 =\n (- 24 * c_4 + - 24 * L * c_3 + 12 * L \<up> 2 * c_2 + 4 * L \<up> 3 * c +\n  - 1 * L \<up> 4 * q_0) /\n - 24,\n 0 = (2 * c_2 + 2 * L * c + - 1 * L \<up> 2 * q_0) / 2]" = f2str f
