(* testexamples for RootratEq, equations mixing fractions and roots
   WN120314 some complicated equations still are outcommented.
   *)

"-----------------------------------------------------------------";
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"------------ tests on predicates  -------------------------------";
"------------ test thm rootrat_equation_left_1 -------------------";
"------------ test thm rootrat_equation_left_2 -------------------";
"------------ test thm rootrat_equation_right_1 ------------------";
"------------ test thm rootrat_equation_right_2 ------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";
(* Note on ERROR "check_elementwise: no set 1 + sqrt x = 3".
  this error popped up with this harmless changeset, which
(1) triggered ["RootEq", "solve_sq_root_equation"] first time, because wrong '' in
    (Try (Repeat (Rewrite_Set ''make_rooteq ''))) was found
(2) correction ''make_rooteq'' led further to "check_elementwise: no set 1 + sqrt x = 3"
  Since the changeset seems have nothing todo with these errors, this indicates that
(a) either method ["RootEq", "solve_sq_root_equation"] & Co are somewhat indeterministic
(b) of this is a case of indeterminism due to something elementary.

*)                               
val thy = @{theory "RootRatEq"};
val ctxt = Proof_Context.init_global thy;

"------------ tests on predicates  -------------------------------";
"------------ tests on predicates  -------------------------------";
"------------ tests on predicates  -------------------------------";
val t1 = ParseC.parse_test ctxt "(-8 - sqrt(x) + x \<up> 2) is_rootRatAddTerm_in x";
val SOME (t,_) = rewrite_set_ ctxt  false RootRatEq_prls t1;
if (UnparseC.term @{context} t) = "False" then ()
 else  error "rootrateq.sml: diff.behav. 1 in is_rootRatAddTerm_in";

val t1 = ParseC.parse_test ctxt "(1/x) is_rootRatAddTerm_in x";
val SOME (t,_) = rewrite_set_ ctxt false RootRatEq_prls t1;
if (UnparseC.term @{context} t) = "False" then ()
 else  error "rootrateq.sml: diff.behav. 2 in is_rootRatAddTerm_in";

val t1 = ParseC.parse_test ctxt "(1/sqrt(x)) is_rootRatAddTerm_in x";
val SOME (t,_) = rewrite_set_ ctxt false RootRatEq_prls t1;
if (UnparseC.term @{context} t) = "False" then ()
 else  error "rootrateq.sml: diff.behav. 3 in is_rootRatAddTerm_in";

val t1 = ParseC.parse_test ctxt "(1/(sqrt(x)+1)) is_rootRatAddTerm_in x";
val SOME (t,_) = rewrite_set_ ctxt false RootRatEq_prls t1;
if (UnparseC.term @{context} t) = "True" then ()
 else  error "rootrateq.sml: diff.behav. 4 in is_rootRatAddTerm_in";

val t1 = ParseC.parse_test ctxt "(3 + 1/(1+sqrt(x))) is_rootRatAddTerm_in x";
val SOME (t,_) = rewrite_set_ ctxt false RootRatEq_prls t1;
if (UnparseC.term @{context} t) = "True" then ()
 else  error "rootrateq.sml: diff.behav. 5 in is_rootRatAddTerm_in";

val t1 = ParseC.parse_test ctxt "(1/(1+sqrt(y)) + 3 + 1/(1+sqrt(x))) is_rootRatAddTerm_in x";
val SOME (t,_) = rewrite_set_ ctxt false RootRatEq_prls t1;
if (UnparseC.term @{context} t) = "True" then ()
 else  error "rootrateq.sml: diff.behav. 6 in is_rootRatAddTerm_in";

val t1 = ParseC.parse_test ctxt "(1/(1+sqrt(x)) + 3 + 1/(1+sqrt(y))) is_rootRatAddTerm_in x";
val SOME (t,_) = rewrite_set_ ctxt false RootRatEq_prls t1;
if (UnparseC.term @{context} t) = "True" then ()
 else  error "rootrateq.sml: diff.behav. 7 in is_rootRatAddTerm_in";

"------------ test thm rootrat_equation_left_1 -------------------";
"------------ test thm rootrat_equation_left_1 -------------------";
"------------ test thm rootrat_equation_left_1 -------------------";
val c = [];
val fmz = ["equality ( - 2 + 1/(1 - sqrt(x))= (0::real))", "solveFor x", "solutions L"];
val (dI',pI',mI') = ("RootRatEq",["univariate", "equation"],["no_met"]);
val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*============ inhibit exn WN120319 ==============================================
(*From final Test_Isac.thy we suddenly have

          nxt = ("Model_Problem", Model_Problem)

which we did not investigate further due to the decision to drop the whole type of equation.
*)
if f2str f = "1 = (0 - - 2) * (1 + - 1 * sqrt x)" then ()
else error "rootrateq.sml: diff.behav. in rootrat_equation_left_1 a";
(*-> Subproblem ("RootRatEq", ["sq", "rootX", "univariate", "equation"])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p''',_,f,nxt,_,pt''') = me nxt p c pt;

(*we investigate, why the next step results in Empty_Tac*)
f2str f = "1 = 2 * (1 + - 1 * sqrt x)";
nxt = ("Rewrite_Set", Rewrite_Set "make_rooteq");
(*... these ar the step's arguments; from these we do directly ...*)
val SOME t = ParseC.term_opt ctxt "1 = 2 * (1 + - 1 * sqrt x)"
val SOME (t, _) = rewrite_set_ thy true make_rooteq t;
UnparseC.term @{context} t = "1 = 2 + - 2 * sqrt x";
(*... which works; thus error must be in script interpretation*)

"~~~~~ fun me, args:"; val (tac, (p:pos'), _, (pt:ctree)) = (nxt, p, c, pt);
val (pt, p) = case Step.by_tactic tac (pt,p) of
	("ok", (_, _, ptp))  => ptp;
"~~~~~ fun Step.do_next, args:"; val (ip as (_,p_), (ptp as (pt,p), tacis)) = (p, ((pt, e_pos'), []))
val pIopt = get_pblID (pt,ip);
ip;    (*= ([3, 2], Res)*)
tacis; (*= []*)
pIopt; (*= SOME ["sq", "rootX", "univariate", "equation"]*)
member op = [Pbl,Met] p_; (*= false*)
"~~~~~ fun do_next, args:"; (*stopped due to strange exn
  "check_elementwise: no set 1 = 2 + - 2 * sqrt x"*)

(*---- 2nd try: we investigate the script ["RootEq", "solve_sq_root_equation"] found via pbl*)
val t = ParseC.parse_test @{context} "((lhs e_e) is_sqrtTerm_in v_v) | ((rhs e_e) is_sqrtTerm_in v_v)";
val t = ParseC.parse_test @{context} ("((lhs (1 = 2 * (1 + - 1 * sqrt x))) is_sqrtTerm_in x) |" ^
                 " ((rhs (1 = 2 * (1 + - 1 * sqrt x))) is_sqrtTerm_in x)");
val SOME (t, _) = rewrite_set_ thy true rooteq_srls t;
UnparseC.term @{context} t = "True | True"; (*...was same in 2002 (NOT "True"); so program seems to take 
  [univariate,equation] and to refine to ["sq", "rootX", "univariate", "equation"] in 2002*)

(*(*these are the errors during stepping into the code:*)
Step_Solve.do_next (pt,ip); (*check_elementwise: no set 1 = 2 + - 2 * sqrt x: fun mk_set raises
  this exn in Check_elementwise ONLY ?!?*)
Step.do_next p ((pt, e_pos'),[]); (* = ("helpless",*)
*)

val (p,_,f,nxt,_,pt) = me nxt p''' c pt''';
f2str f = "1 = 2 + - 2 * sqrt x)"; (* <<<-------------- this should be*)
fst nxt = "Empty_Tac"; (* <<<-------------- this we have*)
(*============ inhibit exn WN120314: stopped due to effort; continue with equ-solver
The equation is strange: it calls script ["RootEq", "solve_sq_root_equation"] twice
and works differently due to an "if" in that script.

if f2str f = "1 = 2 + - 2 * sqrt x" then ()
else error "rootrateq.sml: diff.behav. in rootrat_equation_left_1 b";
(*-> Subproblem ("RootRatEq", ["sq", "rootX", "univariate", "equation"]) ?!? the SAME as above*)
val (p,_,f,nxt,_,pt) = me nxt p c pt; 
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f; 
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f; 
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f; 
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if f2str f = "1 = 4 * x" then ()
else error "rootrateq.sml: diff.behav. in rootrat_equation_left_1 c";
(*-> Subproblem ("PolyEq", ["normalise", "polynomial", "univariate", "equation"])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; 
if f2str f = "1 + -4 * x = 0" then ()
else error "rootrateq.sml: diff.behav. in rootrat_equation_left_1";
(*-> Subproblem ("PolyEq", ["degree_1", "polynomial", "univariate", "equation"])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
case f of Form' (Test_Out.FormKF (~1,EdUndef,0,Nundef,"[x = 1 / 4]")) => ()
	 | _ => error "rootrateq.sml: diff.behav. in  - 2 + 1/(1 - sqrt(x))= 0 -> [x = 1/4]";
============ inhibit exn WN120314 ==============================================*)
============ inhibit exn WN120319 ==============================================*)

"------------ test thm rootrat_equation_left_2 -------------------";
"------------ test thm rootrat_equation_left_2 -------------------";
"------------ test thm rootrat_equation_left_2 -------------------";
val fmz = ["equality (3/(1+sqrt(x))= 1)", "solveFor x", "solutions L"];
val (dI',pI',mI') = ("RootRatEq",["univariate", "equation"],["no_met"]);

val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
(* \<up>  10 *)
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
(*-> Subproblem ("RootEq", ["univariate", ...])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
(* \<up>  20 *)
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;

(*//------------------ ERROR check_elementwise: no set 1 + sqrt x = 3 -----------------------\\* )
val (p,_,f,nxt,_,pt) = me nxt p c pt; 
(*-> Subproblem ("RootEq", ["univariate", ...])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
(* \<up>  30 *)
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; 
(*-> Subproblem ("RootEq", ["univariate", ...])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
(* \<up>  40 *)
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; 
( *\\------------------ ERROR check_elementwise: no set 1 + sqrt x = 3 -----------------------//*)

(*============ inhibit exn WN120314 ==============================================
if f = Form' (Test_Out.FormKF (~1, EdUndef, 0, Nundef, "4 + - 1 * x = 0")) then ()
else error "rootrateq.sml: diff.behav. in rootrat_equation_left_2";
(*-> Subproblem ("PolyEq", ["polynomial", ...])*)
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
case f of Form' (Test_Out.FormKF (~1,EdUndef,0,Nundef,"[x = 4]")) => ()
	 | _ => error "rootrateq.sml: diff.behav. in  3/(1+sqrt(x))= 1 -> [x = 4]";
============ inhibit exn WN120314 ==============================================*)

"------------ test thm rootrat_equation_right_1 ------------------";
"------------ test thm rootrat_equation_right_1 ------------------";
"------------ test thm rootrat_equation_right_1 ------------------";
val fmz = ["equality ( 0= - 2 + 1/(1 - sqrt(x)))", "solveFor x", "solutions L"];
val (dI',pI',mI') = ("RootRatEq",["univariate", "equation"],["no_met"]);

val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
(* \<up>  10 *)
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
(* \<up>  20 *)
(*//------------------ ERROR check_elementwise: no set 1 + sqrt x = 3 -----------------------\\* )
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
(* \<up>  30 *)
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
(* \<up>  40 *)
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; 
( *\\------------------ ERROR check_elementwise: no set 1 + sqrt x = 3 -----------------------//*)

(*============ inhibit exn WN120314: similar complicated equation, dropped.
if f = Form' (Test_Out.FormKF (~1, EdUndef, 0, Nundef, "- 1 + 4 * x = 0")) then ()
else error "rootrateq.sml: diff.behav.ppoly in rootrat_equation_right_1";
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
case f of Form' (Test_Out.FormKF (~1,EdUndef,0,Nundef,"[x = 1 / 4]")) => ()
	 | _ => error "rootrateq.sml: diff.behav. in  - 2 + 1/(1 - sqrt(x))= 0 -> [x = 1/4]";
============ inhibit exn WN120314 ==============================================*)

"------------ test thm rootrat_equation_right_2 ------------------";
"------------ test thm rootrat_equation_right_2 ------------------";
"------------ test thm rootrat_equation_right_2 ------------------";
val fmz = ["equality (1 = 3/(1+sqrt(x)))", "solveFor x", "solutions L"];
val (dI',pI',mI') = ("RootRatEq",["univariate", "equation"],["no_met"]);

val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
(* \<up>  10 *)
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;

(*//------------------ ERROR rls "make_rooteq " missing in Know_Store.
    after repair (Try (Repeat (Rewrite_Set ''make_rooteq ''))) 
    ------------------ ERROR check_elementwise: no set 1 + sqrt x = 3 -----------------------\\* )
(*val (p,_,f,nxt,_,pt) =*) me nxt p c pt;
"~~~~~ fun me , args:"; val (tac, p, _(*NEW remove*), pt) = (nxt, p, c, pt);
      val (pt, p) = 
  	    (*Step.by_tactic is here for testing by me; do_next would suffice in me*)
  	    case Step.by_tactic tac (pt, p) of
  		    ("ok", (_, _, ptp)) => ptp
  	    | ("unsafe-ok", (_, _, ptp)) => ptp
  	    | ("not-applicable",_) => (pt, p)
  	    | ("end-of-calculation", (_, _, ptp)) => ptp
  	    | ("failure", _) => error "sys-error"
  	    | _ => error "me: uncovered case Step.by_tactic"

    (*case*)
      Step.do_next p ((pt, Pos.e_pos'), []) (*of*);
"~~~~~ fun do_next , args:"; val ((ip as (_, p_)), (ptp as (pt, p), tacis))
  = (p, ((pt, Pos.e_pos'), []));
 val pIopt = Ctree.get_pblID (pt, ip);
    (*if*) ip = ([], Pos.Res) (*else*);
      val _ = (*case*) tacis (*of*);
        val SOME _ = (*case*) pIopt (*of*);

  	       switch_specify_solve p_ (pt, ip);
"~~~~~ fun switch_specify_solve , args:"; val (state_pos, (pt, input_pos)) = (p_, (pt, ip));
      (*if*) member op = [Pos.Pbl, Pos.Met] state_pos (*else*);

        LI.do_next (pt, input_pos);
"~~~~~ and do_next , args:"; val (ptp as (pt, pos as (p, p_))) = (pt, input_pos);
    (*if*) MethodC.id_empty = get_obj g_metID pt (par_pblobj pt p) (*else*);
        val thy' = get_obj g_domID pt (par_pblobj pt p);

	      val (_, (ist, ctxt), sc) =
    LItool.resume_prog (p,p_) pt;
"~~~~~ fun resume_prog , args:"; val (thy, (p, p_), pt) = (thy', (p,p_), pt);
  (*if*) Pos.on_specification (p, p_) (*else*);
    val (pbl, p', rls') = parent_node pt pos
    (*if*) pbl (*then*);
	         val metID = get_obj g_metID pt p'
(*["RootEq", "solve_sq_root_equation"] found for correction, which caused ERROR 2*)

(*\\------------------ end ERROR check ------------------------------------------------------//*)

val (p,_,f,nxt,_,pt) = me nxt p c pt;
(* \<up>  20 *)
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
(* \<up>  30 *)
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
(* \<up>  40 *)
val (p,_,f,nxt,_,pt) = me nxt p c pt; 
( *\\------------------ ERROR WN200211 1, 2 -------------------------------------------------//*)

(*============ inhibit exn WN120314 ==============================================
if f = Form' (Test_Out.FormKF (~1, EdUndef, 0, Nundef, "-4 + x = 0")) then ()
else error "rootrateq.sml: diff.behav. in rootrat_equation_right_2";
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; val (p,_,f,nxt,_,pt) = me nxt p c pt;
case f of Form' (Test_Out.FormKF (~1,EdUndef,0,Nundef,"[x = 4]")) => ()
	 | _ => error "rootrateq.sml: diff.behav. in  3/(1+sqrt(x))= 1 -> [x = 4]";
============ inhibit exn WN120314 ==============================================*)

